/*
	ARK X-TRAiN for Java TvvO

	JavavOJNA(Java Native Interface)̋@\X-TRAiN̊֐CALLāA
	GNZubN쐬TvłB

	sɂjna.jarKvłBhttps://github.com/java-native-access/jna

	o͐͒萔BOOK_PATHŃtpXw肷Kv܂B

	RpC
	# javac -cp jna.jar JNA_xtrain.java

	s
	  1. Windows
	  > java -cp .;jna.jar JNA_xtrain

	  2. Linux
	  # export LD_LIBRARY_PATH=.
	  # java -cp .:jna.jar JNA_xtrain

	(c) ARKTRAN,INC.
*/
import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.Platform;
import java.util.Calendar;
import java.text.SimpleDateFormat;


class JNA_xtrain{

	public static final String BOOK_PATH = "C:\\TEMP\\Java_SAMPLE.xlsx";	/* o̓ubÑpX */
/*	public static final String BOOK_PATH = "/tmp/Java_SAMPLE.xlsx";*/	/* o̓ubÑpX */

	public interface JxlsLib extends Library {

		/* X-TRAiN */
		JxlsLib INSTANCE = (JxlsLib) Native.loadLibrary(Platform.isWindows() ? "axls_api" : "axls_api", JxlsLib.class);

		/* X-TRAiN javap֐ */
		String	open_book();
		int	open_sheet(String book, String sheet);
		int	put_cell(String book, String cell, String value);
		int	put_values(String book, String values);
		String	cell_name(String book, int row, int column);
		String	cell_range(String book, int row1, int column1, int row2, int column2);
		int	save_book(String book);
		int	scrap_book(String book);
		int	error_code(String book);
		String	error_mesg(String book);
	}

	public static void main(String[] args){
		int	rc;
		JxlsLib JXLS = JxlsLib.INSTANCE;

		/* JnOo */
		Calendar c = Calendar.getInstance();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyNMMdd Ej");
        sdf.applyPattern("yyyy/MM/dd HH:mm:ss SSS");
        System.out.printf("Jn  %s\n", sdf.format(c.getTime()));

		/* ExcelubNI[v */
		/* ߂lɃubNp\̃AhXƂĕԂ܂̂ŁAȍ~̏Ŏgp܂B*/
		/* Iۂ́Asave_book֐(ۑĐI)܂scrap_book֐(j)CALLKv܂B */
		/* scrap_book֐CALLȂꍇ̓[NN܂ */
		String book = JXLS.open_book();
		if (book == null || book.length() == 0){
			System.out.printf("ERROR:JXLS.open_book()");
			System.exit(-1);
		}

		/* V[gI[v */
		String arguments = "SHEET_NAME=JavaTv MODE=CREATE";
		if (JXLS.open_sheet(book, arguments) != 0){
			String error_mesg = JXLS.error_mesg(book);
			JXLS.scrap_book(book);
			System.out.println(error_mesg);

			System.exit(-1);
		}

		/* ubNݒ */
		/* l⑮̐ݒput_values֐ɁA=ڒl ̌`̈Ŏw肵܂B*/
		/* 󔒂܂̓^uŋ؂Aw肷邱Ƃł܂B */
		arguments = "BOOK=" + BOOK_PATH;
		rc = JXLS.put_values(book, arguments);
		if (rc != 0){
			String error_mesg = JXLS.error_mesg(book);
			JXLS.scrap_book(book);
			System.out.printf("ERROR:JXLS.put_values() rc=%d %s\n", rc, error_mesg);

			System.exit(-1);
		}

		/* 񕝐ݒ */
		arguments = "B.=20 C.=20 D.=20 E.=20";
		rc = JXLS.put_values(book, arguments);
		if (rc != 0){
			String error_mesg = JXLS.error_mesg(book);
			JXLS.scrap_book(book);
			System.out.printf("ERROR:JXLS.open_book() rc=%d %s\n", rc, error_mesg);

			System.exit(-1);
		}

        sdf.applyPattern("yyyy/MM/dd");
        String now_date = sdf.format(c.getTime());

		int line_ct = 0;
		int max_row = 1000;

		/* sJԂ */
		for (int row=1; row<=max_row; row++){

			/*
			  A`EɐlAAtݒ
			*/
			int column = 1;
			String cell1 = JXLS.cell_name(book, row, 1);
			String cell2 = JXLS.cell_name(book, row, 2);
			String cell3 = JXLS.cell_name(book, row, 3);
			String cell4 = JXLS.cell_name(book, row, 4);
			String cell5 = JXLS.cell_name(book, row, 5);
			line_ct++;

			arguments = cell1 + "=" + row + " " + cell2 + "={ꕶ" + row + " " + cell2 + ".tHg.F= " + cell3 + "=" + now_date + " " + cell3 + ".=a " + cell4 + "=ABCDEFG " + cell4 + ".tHg.=\"Arial Black\" " + cell5 + "=12345 " + cell5 + ".=";
			rc = JXLS.put_values(book, arguments);
			if (rc != 0){
				String error_mesg = JXLS.error_mesg(book);
				JXLS.scrap_book(book);
				System.out.printf("ERROR:JXLS.put_values() rc=%d %s\n", rc, error_mesg);

				System.exit(-1);
			}

			/* shԂ */
			if (line_ct % 2 == 0){

				String range = JXLS.cell_range(book, row, 1, row, 5);
				arguments = range + ".hԂ.F=#CCCCCC";

				rc = JXLS.put_values(book, arguments);
				if (rc != 0){
					String error_mesg = JXLS.error_mesg(book);
					JXLS.scrap_book(book);
					System.out.printf("ERROR:JXLS.put_values() rc=%d %s\n", rc, error_mesg);

					System.exit(-1);
				}
			}
		}

		/* \ŜɌrt*/
		String range = JXLS.cell_range(book, 1, 1, max_row, 5);
		arguments = range + ".r=";

		rc = JXLS.put_values(book, arguments);
		if (rc != 0){
			String error_mesg = JXLS.error_mesg(book);
			JXLS.scrap_book(book);
			System.out.printf("ERROR:JXLS.put_values() rc=%d %s\n", rc, error_mesg);

			System.exit(-1);
		}

		/* ExcelubNۑ */
		rc = JXLS.save_book(book);
		if (rc != 0){
			String error_mesg = JXLS.error_mesg(book);
			JXLS.scrap_book(book);
			System.out.printf("ERROR:JXLS.save_book() rc=%d %s\n", rc, error_mesg);

			System.exit(-1);
		}

		/* IOo */
		c = Calendar.getInstance();
        sdf = new SimpleDateFormat("yyyyNMMdd Ej");
        sdf.applyPattern("yyyy/MM/dd HH:mm:ss SSS");
        System.out.printf("I  %s\n", sdf.format(c.getTime()));
        System.out.printf("ExcelubN%so͂܂B\n", BOOK_PATH);
	}
}
